%  leslie1.m
% Matlab file for Part 1 of the Leslie Growth Models
% module

disp('*********************************************')
disp('Part 1:  Age-distributed growth ')
disp('*********************************************')
disp('  ')    

    format short
    
    disp('Step 1:')
    disp('We define the Leslie matrix L.  First we define')
    disp('symbolic variables a1, a2, ... ,a12 and put them ')
    disp('into the first row of L.  Then we put the symbolic')
    disp('variables b1, b2, ... ,b11 on the sub-diagonal')
    disp('using a ''for'' loop.')
    disp(' ')
    disp('Make your window wide so you can fully display L.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  syms a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12 ')
    disp('  syms b1 b2 b3 b4 b5 b6 b7 b8 b9 b10 b11 ')
    disp('  a=[a1 a2 a3 a4 a5 a6 a7 a8 a9 a10 a11 a12]; ')
    disp('  b=[b1 b2 b3 b4 b5 b6 b7 b8 b9 b10 b11]; ')
    disp(' ')
    disp('  L(1,:) = a; ')
    disp('  for i=2:12 ')
    disp('     L(i,:) = zeros(1,12); ');
    disp('     L(i,i-1) = b(i-1); ')
    disp('  end ')
    disp('  L ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 2: ')
    disp('The following MATLAB commands find the ')
    disp('characteristic polynomial of L.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  syms lam ')
    disp('  pfun=det( L - lam*eye(12) ) ')
    disp('  pretty(pfun)    % Gives nice display ')
    disp(' ')
    disp('----------------------------------------------')
    disp('Describe the pattern you see in the coefficients ')
    disp('of the powers of lambda ')
    disp('Use MATLAB comments in your diary file. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 3 and 4:')
    disp('These commands construct an auxiliary function')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp(' qfun=a(1)/lam; ')
    disp(' c=1; ')
    disp(' for i=2:12 ')
    disp('   c = c*b(i-1);')
    disp('   qfun = qfun + a(i)*c/lam^i; ')
    disp(' end ')
    disp(' qfun ')
    disp(' pretty(qfun) ')
    disp(' ')
    disp('----------------------------------------------')
    disp('Explain why pfun(lam) = 0 if and only if ')
    disp('qfun(lam) = 1. Explain why qfun(lam) must be a ')
    disp('strictly decreasing function for lam > 0. ')
    disp('Then explain why L must have exactly one positive ')
    disp('eigenvalue, i.e., one positive root of the char ')
    disp('polynomial pfun. ')
    disp('Use MATLAB comments in your diary file. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('---------------------------------------------------')
    disp('Step 5: ')
    disp('Now we assign values to the parameters of the model ')
    disp('and then plot pfun and qfun. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  a1=0; a2=0.045; a3=0.391; a4=0.472; a5=0.484; ')
    disp('  a6=0.546; a7=0.543; a8=0.502; a9=0.468; a10=0.459; ')
    disp('  a11=0.433; a12=0.421; ')
    disp('  b1=0.845; b2=0.975; b3=0.965; b4=0.950; b5=0.926; ')
    disp('  b6=0.895; b7=0.850; b8=0.786; b9=0.691; ')
    disp('  b10=0.561; b11=0.370; ')
    disp('  L=double( subs(L) ) ')
    disp('  pfun=subs(pfun); ')
    disp('  qfun=subs(qfun); ')
    disp(' ')
    disp('  figure(1); ezplot(qfun,[0,2]); axis([0,2,0,10]) ')
    disp('  grid on; legend(''q(lam)''); ')
    disp('  figure(2); ezplot(pfun,[-2,2]); axis([-2,2,-2,2]) ')
    disp('  grid on; legend(''p(lam)''); ')
    disp(' ')
    disp('---------------------------------------------------')
    disp('Explain how the plots show that L has exactly one ')
    disp('positive eigenvalue and estimate this eigenvalue. ')
    disp('Answer using MATLAB comments in your diary file. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 6: ')
    disp('The following MATLAB command finds the ')
    disp('eigenvalues of L directly.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  eigvals=eig(L) ')
    disp(' ')
    disp('----------------------------------------------')
    disp('Interpret the output.  Find the one positive ')
    disp('eigenvalue. ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;
    disp(' ')

    disp('----------------------------------------------')
    disp('Step 7: ')
    disp('For a general Leslie matrix, not necessarily this ')
    disp('example, if x is a state vector which also happens ')
    disp('to be the eigenvector corresponding to the positive ')
    disp('eigenvalue, find formulas for   ')
    disp('  1. the percentage increase in population ')
    disp('     over the next year, ')
    disp('  2. the change in the distribution over age classes')
    disp('     for that year.')
    disp(' ')
    disp('Answer using MATLAB comments in your diary file.')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('----------------------------------------------')
    disp('Step 8: ')
    disp('The following MATLAB commands finds the eigenvector')
    disp('corresponding to the positive eigenvalue and finds ')
    disp('its length. ')
    disp('Enter: ')
    disp(' ')
    disp('  [V,D] = eig(L); ')
    disp('  eigvec1 = V(:,1) ')
    disp('  sum1 = sum(eigvec1) ')
    disp(' ')
    disp('------------------------------------------------')
    disp('Modify the eigenvector to make it a state vector.')
    disp('Describe what it tells you about a distribution')
    disp('into age classes. ')

    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')

    keyboard;   
    disp(' ')
    
    disp('----------------------------------------------')
    disp('Step 9: ')
    disp('Starting with the state vector from step 8, find')
    disp('compute the age distribution vector after one year,')
    disp('after 10 years. ')
    disp(' ')
    disp(' ')
    disp('----------------------------------------------')
    disp('To go on to part 2 of this module, ')
    disp('type: leslie2')
    disp(' ')